
#include "aes.h"

char byteIn; // tmp byte read from serial

//PINS FOR TRIGGER
unsigned pinTrigger = 19; //A5; on ULB board
//TODO : unsigned pinTrigger2 = ??; //A?; on ULB board

unsigned char key [Nrows][Ncols];
unsigned char workState [Nrows][Ncols];
unsigned char state[Nrows][Ncols];

void setup(){
  Serial.begin(9600); //setup communication
  randomSeed(1);  //setup random numbers
  
  //setup trigger pins
  pinMode(pinTrigger, OUTPUT);
  digitalWrite(pinTrigger, LOW);
  
  //setup key (will not change during execution)
  // KEY : 0x 33BBAA55 00010203 0E70766E FCFDFEFF
  
  key[0][0] = 0x33;  key[0][1] = 0x00;  key[0][2] = 0x0E;  key[0][3] = 0xFC;
  key[1][0] = 0xBB;  key[1][1] = 0x01;  key[1][2] = 0x70;  key[1][3] = 0xFD;
  key[2][0] = 0xAA;  key[2][1] = 0x02;  key[2][2] = 0x76;  key[2][3] = 0xFE;
  key[3][0] = 0x55;  key[3][1] = 0x03;  key[3][2] = 0x6E;  key[3][3] = 0xFF;  
}

void loop(){
  if (Serial.available() > 0){
    byteIn = Serial.read(); //read command byte
    Serial.println(byteIn);
    if (byteIn == 'c'){      
      initState(state, workState);
      digitalWrite(pinTrigger, HIGH);
      cipher(workState, key);
      digitalWrite(pinTrigger, LOW);
    }else if (byteIn == 'v'){
      //change values, keys, message, etc
      changeValue(state);
    }else if(byteIn == 'p'){
      // print hex value of random values
      printStateHex(state);
    }else if(byteIn == 'k'){
      printStateHex(key);
    }else{
      Serial.println("Unknown command");
    }
  }
}

void changeValue(unsigned char state[][Ncols]){
  for(unsigned char i=0; i<Nrows;++i){
    for(unsigned char j=0; j<Ncols;++j){
      state[i][j] = random(256);
    }
  }
}

void initState(unsigned char state[][Ncols], unsigned char workState[][Ncols]){
  for(unsigned char i=0; i<Nrows;++i){
    for(unsigned char j=0; j<Ncols;++j){
      workState[i][j] = state[i][j];
    }
  }
}

void printStateHex(unsigned char state[][Ncols]){
  for(unsigned char i=0; i<Nrows;++i){
    for(unsigned char j=0; j<Ncols;++j){
      printHex(state[j][i]);
      Serial.print(", ");
    }
  }
  Serial.println();
}

char tmp[2];
void printHex(unsigned char value){
  //Serial.print("0x");Serial.print(state[j][i], HEX);
  sprintf(tmp, "%02X", value);
  Serial.print("0x");
  Serial.print(tmp);
}
